open util/ordering[Time]

sig Time {}
sig Guest {}
sig Room {}

one sig FrontDesk {
    occupant: (Room -> Guest) -> Time
}

fact {
    // No guest in 2 different rooms at any time
    all disj r, r': Room, g: Guest |not (g in FrontDesk.occupant[r].Time and
                                                                     g in FrontDesk.occupant[r'].Time)
    // No room has 2 different guest at any time
    all disj g, g': Guest, r: Room |not (g in FrontDesk.occupant[r].Time and
                                                                     g' in FrontDesk.occupant[r].Time)
    // Every room is occupied at every time
    all r: Room, t: Time | some FrontDesk.occupant[r].t
}

pred Show {}
run Show for exactly 3 Time, exactly 3 Room, exactly 3 Guest
